import { http } from "@/utils/http";
import { ref } from "vue";
// 部门
type addDept = {
  code: number;
  msg: string;
  data: boolean;
};
type addDeptList = {
  code: number;
  msg: string;
  data: Array<any>;
};

export const postAddDept = data => {
  return http.request<addDept>("post", "/sysDept/addDept", { data });
};
export const postDelDept = data => {
  return http.request<addDept>("post", "/sysDept/delDept", { data });
};
export const postListTree = () => {
  return http.request<addDeptList>("post", "/sysDept/listTree");
};
export const postUpdateDept = data => {
  return http.request<addDept>("post", "/sysDept/updateDept", { data });
};
// 部门下新建人员
export const postDeptUserAdd = data => {
  return http.request<addDept>("post", "/sysDept/deptUserAdd", { data });
};
// 部门下树（包含用户信息）
export const postListTreeWithUser = () => {
  return http.request<addDeptList>("post", "/sysDept/listTreeWithUser");
};
export const treeDept = ref([]);
export const postListTreeWithUserApi = async () => {
  const res = await postListTreeWithUser();
  treeDept.value = transformData(res.data);
  console.log("过滤的数据.", treeDept.value);
};
const transformData = data => {
  return data.map(item => {
    const transformedItem = {
      userName: item.userName || item.deptName,
      userCode: item.userCode || item.deptCode,
      children: []
    };

    if (item.childrenRes) {
      transformedItem.children = transformData(item.childrenRes);
    }

    if (item.childrenUserRes) {
      item.childrenUserRes.forEach(user => {
        transformedItem.children.push({
          userName: user.userName,
          userCode: user.userCode,
          children: []
        });
      });
    }

    return transformedItem;
  });
};
